# Contributing

We welcome all types of contribution.

Need a feature or found a bug? Please create an [issue](https://github.com/iTwin/iTwinUI/issues).

Have a question or suggestion? Please create a [discussion](https://github.com/iTwin/iTwinUI/discussions).

## v2 → v3 Migration

### Directory Structure

- `/codemods`: Contains codemod files
- `/codemods/tests`: Contain files that define the unit test for a codemod. So it defines the path of the test files, test name, etc.
- `/codemods/__testfixtures__`:
  - Contains the input and expected output files that are used in the unit tests. So `<codemod-name>.input.tsx` contains old code from v2. `<codemod-name>.output.tsx` contains the new code that we expect the codemod to return.
  - After running `yarn test`, if the actual codemod output does not match the output file output, that unit test will fail and the exact diff will be shown in the CLI.
  - Tests could fail even if just the formatting of the two code outputs don't match. Thus, the `.output.tsx` file is intentionally formatted manually to match the codemod (later we can autoformat the codemod output to match the auto formatted output file).

### Tips to review codemod PRs

- The first step would be to run `yarn test` and ensure that all tests pass.
- (Optional) If they pass, you can add your test cases to the `.input.tsx` file in `/codemods/__testfixtures__` and the expected output to the corresponding `.output.tsx` file. You might need to "save without formatting" ([link](https://stackoverflow.com/a/63480681/11547064))
  - Rerun `yarn test` to confirm the codemod works with your cases too.
  - Optionally, you can commit and push your test cases if they work to add to the test cases.
- (Optional) You can run `yarn dev` and go to `localhost:3000/v3`, enter a folder path with v2 files, set filters, and click the run button. You can then manually go through all files in that folder to confirm the codemod worked as you expected.
- Lastly, you can skim through the actual codemod file. This is not as important as the unit tests because the output of the codemod is more important than the codemod code.
