<p align="center">
  <picture>
    <source
      media='(prefers-color-scheme: dark)'
      srcSet='https://itwinplatformcdn.azureedge.net/iTwinUI/iTwinUI-new-dark-logo.png'
    />
    <img
      src='https://itwinplatformcdn.azureedge.net/iTwinUI/iTwinUI-new-logo.png'
      alt='iTwinUI logo'
    />
  </picture>
</p>

<h1 align="center">iTwinUI Migration Tool</h1>

## What is this tool for?

This tool helps to automate the migration to newer major versions of iTwinUI. We offer two versions of this tool:

- iTwinUI v2 → v3 ([Oct 23, 2023](https://github.com/iTwin/iTwinUI/releases/tag/%40itwin%2Fitwinui-react%403.0.0))
- iTwinUI v1 → v2 ([Nov 15, 2022](https://github.com/iTwin/iTwinUI/releases/tag/%40itwin%2Fitwinui-react%402.0.0))

### iTwinUI v2 → v3

This is a frontend to run [`jscodeshift`](https://github.com/facebook/jscodeshift) codemods effectively.

- v3 tool home page (`/v3`)
  <img src="screenshots/v3_home_page.png" alt="" />
  - When starting fresh:
    - Enter the path to your repository below.
      - Only `.tsx`, `.ts`, `.js`, `.jsx` files are considered
      - gitignored and untracked files will be ignored
    - Clicking the `Dry-run codemods` button will do a dry run of the codemods.
      - **NOTE**: This may take a while, depending on the size of the repo.
  - If you already ran this tool before:
    - We save your previous run. So you can either continue your previous run. Or you can start a new run (would **discard** the old run results).  
      <img src="screenshots/v3_continue_previous_run.png" alt ="" />
- Preview page (`/v3/preview`)
  <img src="screenshots/v3_preview_page.png" alt="" />
  - This page shows the dry-run output of all the codemods we tried to run on your repo
  - Per-file
    <img src="screenshots/v3_preview_row_expanded.png" alt="" />
    - Expand a row to see what codemods were applicable for that file and see the code diff
    - Toggle checkboxes to select which codemods to run on the file
    - Click "Run x codemods" to actually run the codemods.
    - Click "Ignore file" to move the file to the "Ignored" tab
  - Bulk run
    - Select multiple rows using the row checkboxes. Then click "Run codmeods in x files". This runs the codemods on all the selected files.
- Results page (`/v3/results`)
  <img src="screenshots/v3_results_page.png" alt="" />
  - It is **very important** to go to the results page after running codemods on the user's preferred files.
  - These are required (or sometimes optional) suggestions that you need to act upon manually or tidbits of information to help you make an informed decision.
  - To be sure you have addressed the manual suggestions correctly, you can optionally re-run the tool.

---

### iTwinUI v1 → v2

This uses basic find-and-replace.

- See migration suggestions grouped by files or rules
  <br/>
  <img src="screenshots/home_screen.png" />

- Run batch commands to speed up migration
  <br/>
  <img src="screenshots/bulk_tasks.png" />

---

## How to run this tool?

- Install deps
  - `npm i`
- Build: Run in the beginning
  - `npm run build`
- Start: To start the tool
  - `npm run start`
- Update: **Recommended** to run this whenever the tool detects a new version
  - `npm run update`

---

## Questions

Feel free to ask questions on [iTwinUI Discussions](https://github.com/iTwin/iTwinUI/discussions).

For a list of frequently asked questions, visit the [iTwinUI wiki](https://github.com/iTwin/iTwinUI/wiki/FAQ).
