"use client";

import { ThemeProvider, ThemeType } from "@itwin/itwinui-react";
import { AppThemeContext } from "modules/contexts/contexts";
import React from "react";

export default function AppThemeProvider({
	children,
}: {
	children: React.ReactNode;
}) {
	const [theme, setTheme] = React.useState<ThemeType>("os");

	return (
		<AppThemeContext.Provider
			value={{
				theme,
				setTheme,
			}}
		>
			<ThemeProvider theme={theme}>{children}</ThemeProvider>
		</AppThemeContext.Provider>
	);
}
