"use client";

import { useToaster } from "@itwin/itwinui-react";
import { setGlobalToaster } from "modules/globals/toaster";
import React from "react";

/**
 * Used for initializing `globalToaster`
 */
export const ToasterProvider = ({
	children,
}: {
	children: React.ReactNode;
}) => {
	const toaster = useToaster();
	React.useEffect(() => {
		toaster.setSettings({
			placement: "bottom-end",
			order: "descending",
		});
	}, [toaster]);

	// TODO: Maybe remove
	// Initialize toaster
	setGlobalToaster(toaster);

	return children;
};
