import AppThemeProvider from "app/(routes)/AppThemeProvider";
import React from "react";
import "@itwin/itwinui-react/styles.css";
import "styles/globals.css";
import { Metadata } from "next";
import { AppHeader } from "./AppHeader";
import styles from "./layout.module.scss";

export const metadata: Metadata = {
	title: "iTwinUI Migration Tool",
	icons: ["./favicon.svg"],
};

export default function RootLayout({
	children,
}: {
	children: React.ReactNode;
}) {
	return (
		<html>
			<body>
				<AppThemeProvider>
					<div className={styles.App}>
						<AppHeader showInput={false} />
						<div className={styles.Content}>{children}</div>
					</div>
				</AppThemeProvider>
			</body>
		</html>
	);
}
