import { Flex, Text } from "@itwin/itwinui-react";
import type { LatestRunFile } from "utils/latestFileRun";
import { readOutputFile } from "app/_actions/readOutputFile";

export const ResultStats = async () => {
	const latestRunFile = await readOutputFile();

	return (
		<Flex flexDirection="column" gap="l" alignItems="stretch">
			{latestRunFile != null && <TitleAndDescription latestRunFile={latestRunFile} />}
		</Flex>
	);
};

const TitleAndDescription = ({
	latestRunFile,
}: {
	latestRunFile: LatestRunFile;
}) => {
	const numFilesAutoChangeMade = latestRunFile.files
		.filter((f) => f.state === "finished-running")
		.map((file) => (file.stages.length > 0 ? 1 : 0) as number)
		.reduce((a, b) => a + b, 0);

	return (
		<Flex flexDirection="column" alignItems="flex-start">
			<Text variant="title" as="h1">
				Results
			</Text>
			{/* TODO: Better UI */}
			<Text>
				{`We were able to make automatic changes in ${numFilesAutoChangeMade} ${
					numFilesAutoChangeMade === 1 ? "file" : "files"
				}! There were some places where automatic changes were not possible. Scroll to the suggestions section to know what changes to make manually (manual required changes) or to see some tidbits of information (manual optional changes).`}
			</Text>
		</Flex>
	);
};
