"use server";

import type { LatestRunFile } from "utils/latestFileRun";
import * as fs from "fs";
import * as path from "path";

/**
 * @returns `LatestRunFile`, or `null` if the file does not exist
 */
export const readOutputFile = async () => {
	const currentDir = process.cwd();
	const outputFilePath = path.join(currentDir, "logs/v3/latest_run.json");

	if (!fs.existsSync(outputFilePath)) {
		return null;
	}

	const fileContents = fs.readFileSync(outputFilePath, "utf-8");
	return JSON.parse(fileContents) as LatestRunFile;
};
