"use client";

import * as React from "react";
import { Anchor, useToaster } from "@itwin/itwinui-react";
import { openFileWithDefaultSystemApplication } from "app/_actions/openFileWithDefaultSystemApplication";
import { useFormState } from "react-dom";

export const OpenFileInIDELink = ({
	children,
	filePath,
}: {
	children: React.ReactNode;
	filePath: string;
}) => {
	const toaster = useToaster();
	const [state, action] = useFormState(openFileWithDefaultSystemApplication, null);

	const closeInfoToast = React.useRef(() => {});

	React.useEffect(() => {
		if (state?.error) {
			closeInfoToast.current?.();
			closeInfoToast.current = () => {};
			toaster.negative("Error opening file");
		}
	}, [state, toaster]);

	return (
		<form action={action}>
			<Anchor
				as="button"
				type="submit"
				name="file-path"
				value={filePath}
				onClick={() => {
					const { close } = toaster.informational(
						"Trying to open file with default system application",
						{ duration: 3500 },
					);
					closeInfoToast.current = close;
				}}
			>
				{children}
			</Anchor>
		</form>
	);
};
