"use client";

import { Button, ProgressRadial, IconButton } from "@itwin/itwinui-react";
import * as React from "react";
import { useFormStatus } from "react-dom";
import styles from "./SubmitButton.module.scss";

export const SubmitButton = React.forwardRef(function SubmitButton(
	{ children, ...props }: React.ComponentProps<"button">,
	ref: React.ForwardedRef<HTMLButtonElement>,
) {
	const { pending } = useFormStatus();

	return (
		<Button
			as={pending ? IconButton : "button"}
			type="submit"
			styleType="high-visibility"
			className={styles["submit-btn"]}
			disabled={pending}
			label={pending ? "Processing…" : undefined}
			{...props}
			ref={ref}
		>
			{pending ? (
				<ProgressRadial className={styles["progress-indicator"]} size="small" />
			) : (
				children
			)}
		</Button>
	);
});
