import ora from "ora";
import simpleGit from "simple-git";

const runCli = async () => {
	console.log("");

	let spinner = ora("Checking/Pulling latest tool updates (recommended)").start();

	const appDir = process.cwd();

	try {
		const git = simpleGit(appDir);
		await git.pull("origin", "main");
		spinner.succeed("😎 You have the latest version of the tool");
	} catch (e) {
		spinner.fail(`Error running "git pull". Try running "git pull" manually (recommended)`);
	}
};

runCli();
