import * as React from "react";
// Don't remove unused imports automatically since they may still be used outside of Breadcrumbs.
import { Breadcrumbs, Button } from "@itwin/itwinui-react";

// Passing children directly
const Component1 = () => {
  return (
    <Breadcrumbs>
      <a href="/">Item 1</a>
      <Button onClick={() => {}}>Item 2</Button>
      <span>Item 3</span>
    </Breadcrumbs>
  );
};

// Passing children as an array
const Component2 = () => {
  return (
    <Breadcrumbs>
      {[
        <a key={1} href="/">
          Item 1
        </a>,
        <Button key={2} onClick={() => {}}>
          Item 2
        </Button>,
        <span key={3}>Item 3</span>,
      ]}
    </Breadcrumbs>
  );
};

// Passing children in a loop
const Component3 = () => {
  return (
    <Breadcrumbs>
      {["Item 1", "Item 2", "Item 3"].map((item, index) => (
        <a key={index} href="/">
          {item}
        </a>
      ))}
    </Breadcrumbs>
  );
};
