import * as React from "react";
// Don't remove unused imports automatically since they may still be used outside of Breadcrumbs.
import { Breadcrumbs, Button } from "@itwin/itwinui-react";

// Passing children directly
const Component1 = () => {
  return (
    (<Breadcrumbs>
      <Breadcrumbs.Item href="/">Item 1</Breadcrumbs.Item>
      <Breadcrumbs.Item onClick={() => {}}>Item 2</Breadcrumbs.Item>
      <Breadcrumbs.Item>Item 3</Breadcrumbs.Item>
    </Breadcrumbs>)
  );
};

// Passing children as an array
const Component2 = () => {
  return (
    (<Breadcrumbs>
      {[
        <Breadcrumbs.Item key={1} href="/">
          Item 1
        </Breadcrumbs.Item>,
        <Breadcrumbs.Item key={2} onClick={() => {}}>
          Item 2
        </Breadcrumbs.Item>,
        <Breadcrumbs.Item key={3}>Item 3</Breadcrumbs.Item>,
      ]}
    </Breadcrumbs>)
  );
};

// Passing children in a loop
const Component3 = () => {
  return (
    (<Breadcrumbs>
      {["Item 1", "Item 2", "Item 3"].map((item, index) => (
        <Breadcrumbs.Item key={index} href="/">
          {item}
        </Breadcrumbs.Item>
      ))}
    </Breadcrumbs>)
  );
};