import { MenuItem } from "@itwin/itwinui-react";
import { SvgCrop } from "@itwin/itwinui-icons-react";

const dropdownMenuItems = (close: () => void) => {
  const cropIcon = <SvgCrop />;
  const props = {
    icon: <SvgCrop />,
    badge: <SvgCrop />,
  };

  return [
    // icon
    <MenuItem key={1} onClick={() => close()} icon={<SvgCrop />}>
      Crop
    </MenuItem>,
    // badge
    <MenuItem key={2} onClick={() => close()} badge={<SvgCrop />}>
      Crop
    </MenuItem>,
    // both icon and badge
    <MenuItem
      key={3}
      onClick={() => close()}
      icon={<SvgCrop />}
      badge={<SvgCrop />}
    >
      Crop
    </MenuItem>,
    // icon/badge as variable
    <MenuItem key={4} onClick={() => close()} icon={cropIcon} badge={cropIcon}>
      Crop
    </MenuItem>,
    // icon/badge as spread attribute (no action)
    <MenuItem key={5} onClick={() => close()} {...props}>
      Crop
    </MenuItem>,

    // When using icon and startIcon, we should show a warning saying to switch to only use startIcon.
    <MenuItem
      key={6}
      onClick={() => close()}
      icon={<SvgCrop />}
      startIcon={<SvgCrop />}
    >
      Crop
    </MenuItem>,
    // When using badge and endIcon, we should show a warning saying to switch to only use endIcon.
    <MenuItem
      key={7}
      onClick={() => close()}
      badge={<SvgCrop />}
      endIcon={<SvgCrop />}
    >
      Crop
    </MenuItem>,
  ];
};
