import path from "path";
import fs from "fs";
import { runCodemodTransform } from "../../../modules/v3/logic/codemods";
import { supportedCodemods } from "../../codemods";
import { describe, test, expect } from "vitest";

describe("only-itwinui", () => {
	test("only-itwinui", () => {
		const testsFolder = path.join(__dirname, "..");
		const testFixtureFolder = path.join(testsFolder, "..", "__testfixtures__/others");

		const testFixtureInputPath = path.join(testFixtureFolder, "only-itwinui.input.tsx");
		const testFixtureOutputPath = path.join(testFixtureFolder, "only-itwinui.output.tsx");

		// ------------------------------------------------------------------------------------------------
		// Run all codemods

		let currentCode = fs.readFileSync(testFixtureInputPath) + ""; // + "" to convert the Buffer to a string

		for (const codemod of supportedCodemods) {
			const transformedCode = runCodemodTransform({
				codemod: codemod,
				filePath: testFixtureInputPath,
				codeInput: currentCode,
			});

			if (transformedCode == null) {
				expect(false);
				throw "oops";
			}

			currentCode = transformedCode;
		}

		// ------------------------------------------------------------------------------------------------
		// Compare outputs

		const currentOutputFileContents = fs.readFileSync(testFixtureOutputPath) + "";
		expect(currentOutputFileContents).toBe(currentCode);
	});
});
