export type SupportedCodemods = typeof supportedCodemods[number];

/**
 * The list of supported codemods in the order they should be run
 */
export const supportedCodemods = [
	"checkbox-move-style-class-inside",
	"tile-iconbutton-size",
	"splitbutton-classname",
	"radiotile-move-style-class-inside",
	"setfocus-removed",
	"usetheme-deprecated",
	"deprecated-typography",
	"menuitem-icon-badge-deprecated",

	// Run "usetoaster-inside-themeprovider" after "toaster-to-usetoaster"
	// since the former assumes that useToaster (and not toaster) is used
	"toaster-to-usetoaster",
	"usetoaster-inside-themeprovider",

	"sidenavigation-move-style-class-inside",
	"breadcrumbs-children",
	"usericon-deprecated",
	"react-table-import",

	// Keep remove-import-props at the end so that it can remove any props added in the other codemods
	"remove-import-props",
] as const;
