/*---------------------------------------------------------------------------------------------
 * Copyright (c) Bentley Systems, Incorporated. All rights reserved.
 * See LICENSE.md in the project root for license terms and full copyright notice.
 *--------------------------------------------------------------------------------------------*/
export type MatchLine = {
	line_number: number;
	columnNumber: number;
	line: string;
	replace: string;
	replaceRule: string;
	with: string;
	type: "autoswap" | "manual" | "suggestion";
	description?: string;
	changed: boolean;
};

export type MatchFile = {
	fileName: string;
	matchLines: MatchLine[];
};

export type MatchRule = {
	replace: string;
	with: string;
	is_regex: boolean;
	type: "autoswap" | "manual" | "suggestion";
	description: string;
};

export type iTwinPackage = "itwinui-css" | "itwinui-variables" | "itwinui-react";

export type FolderInfo = {
	filesFoundCount: number;
};

export type ToastMessage = {
	type: "informational" | "positive" | "negative";
	content: React.ReactNode | string;
};
