"use client";

import React, { MutableRefObject } from "react";
import { FileStructure } from "components/FileTree/FileTree";
import { iTwinPackage, MatchFile, MatchLine, FolderInfo } from "data/file_types";
import { ThemeType } from "@itwin/itwinui-react";

export const RulesContext = React.createContext<{
	packagesToScan: iTwinPackage[];
	setPackagesToScan: any;
}>({
	packagesToScan: [],
	setPackagesToScan: () => {},
});

export const AppThemeContext = React.createContext<{
	theme: ThemeType;
	setTheme: React.Dispatch<React.SetStateAction<ThemeType>>;
}>({
	theme: "light",
	setTheme: () => {},
});

export const MatchesContext = React.createContext<{
	matches: MatchFile[];
	setMatches: any;
	gettingMatches: boolean;
	setGettingMatches: any;
	fileTree: FileStructure | undefined;
	setFileTree: any;
	selectedFilters: (MatchLine["type"] | "completed")[];
	setSelectedFilters: any;
	lockAllOperations: boolean;
	setLockAllOperations: any;
}>({
	matches: [],
	setMatches: () => {},
	gettingMatches: false,
	setGettingMatches: () => {},
	fileTree: {
		name: "",
		path: "",
		children: [],
	},
	setFileTree: () => {},
	selectedFilters: [],
	setSelectedFilters: () => {},
	lockAllOperations: false,
	setLockAllOperations: () => {},
});

export const RepoFolderContext = React.createContext<{
	repoFolder: MutableRefObject<string> | null;
	foundRepoFolder: boolean;
	setFoundRepoFolder: any;
	folderInfo: FolderInfo | null;
	setFolderInfo: any;
}>({
	repoFolder: null,
	foundRepoFolder: false,
	setFoundRepoFolder: () => {},
	folderInfo: null,
	setFolderInfo: () => {},
});
