import type { AppProps } from "next/app";
import "@itwin/itwinui-react/styles.css";
import { AppThemeContext } from "modules/contexts/contexts";
import React from "react";
import { ThemeProvider, ThemeType } from "@itwin/itwinui-react";

import "styles/globals.css";

export default function App({ Component, pageProps }: AppProps) {
	const [theme, setTheme] = React.useState<ThemeType>("os");

	return (
		<AppThemeContext.Provider value={{ theme, setTheme }}>
			<ThemeProvider theme={theme as ThemeType}>
				<main>
					<Component {...pageProps} />
				</main>
			</ThemeProvider>
		</AppThemeContext.Provider>
	);
}
