import type { NextApiRequest, NextApiResponse } from "next";
import { getAllFilesAndFoldersJSON } from "scanner/logic";

export default async function handler(req: NextApiRequest, res: NextApiResponse) {
	const repoFolder = req.query.repoFolder;
	if (typeof repoFolder === "string") {
		const result = await getAllFilesAndFoldersJSON(repoFolder);
		if (result == null) {
			res.status(500).send(`Error scanning provided folder: ${repoFolder}`);
		} else {
			res.send(result);
		}
	} else {
		res.status(422).send("Incorrect input");
	}
}
