import { iTwinPackage } from "data/file_types";
import type { NextApiRequest, NextApiResponse } from "next";
import { getRulesFromFile } from "scanner/logic";

export default async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method !== "GET") {
		res.status(405).send("Method not allowed");
		return;
	}

	try {
		let rules = null;
		if (req.query.packagesToScan) {
			rules = await getRulesFromFile(req.query.packagesToScan as iTwinPackage[]);
		}

		if (rules == null) {
			throw "";
		} else {
			res.send(rules);
		}
	} catch (e) {
		res.status(500).send("Error getting rules");
	}
}
